VERSION 5.00
Begin VB.UserControl MoveButton 
   ClientHeight    =   1065
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3240
   ScaleHeight     =   1065
   ScaleWidth      =   3240
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   2520
      Top             =   240
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
End
Attribute VB_Name = "MoveButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private Const TimeBetweenSteps = 20
Private Const NumberOfStepsToTake = 150

Dim m_Control As Control
Dim FollowStepCount As Integer

Dim DeltaX As Integer
Dim DeltaY As Integer

'might be useful, an event that I fire when the control reaches its destination.
Event ReachedDestination(X As Single, Y As Single)


Property Let ButtonCaption(ByVal newCap As String)
    Command1.Caption = newCap
End Property

Property Get ButtonCaption() As String
    ButtonCaption = Command1.Caption
End Property

Private Sub Timer1_Timer()
    FollowStepCount = FollowStepCount - 1
    
    'here's the actual move.  Just add the delta to the current position and go.
    UserControl.Extender.Move UserControl.Extender.Left + DeltaX, UserControl.Extender.Top + DeltaY
    
    'disable the moving when the step count reaches zero.
    If FollowStepCount = 0 Then
        Timer1.Enabled = False
        RaiseEvent ReachedDestination(UserControl.Extender.Left, UserControl.Extender.Top)
    End If
End Sub

Private Sub UserControl_Initialize()
    Command1.Caption = UserControl.Name
End Sub

Private Sub UserControl_Resize()
    'blah blah, make pretty code.
    Command1.Width = UserControl.Width
    Command1.Height = UserControl.Height
End Sub

Public Function FollowControl(TheControl As Control) As Variant
    ' set the interval and control to move towards
    Timer1.Interval = TimeBetweenSteps
    Set m_Control = TheControl
    
    'calculate a delta x and a delta y, these are used for distance per step.
    DeltaX = (m_Control.Left - UserControl.Extender.Left) / NumberOfStepsToTake
    DeltaY = (m_Control.Top - UserControl.Extender.Top) / NumberOfStepsToTake
    
    'set the number of steps and start the timer!
    FollowStepCount = NumberOfStepsToTake
    Timer1.Enabled = True
End Function

Public Function StopFollowing() As Variant
    'this method (accessible outside the usercontrol) can be used to stop an animation mid-animation.
    Timer1.Enabled = False
End Function
